Public Class Form1

    Private Sub OriginalFileBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OriginalFileBrowse.Click

        If (OriginalFileEdit.Text.Length > 0) Then
            OpenFileDialog1.FileName = OriginalFileEdit.Text
        End If


        If (OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            OriginalFileEdit.Text = OpenFileDialog1.FileName
        End If

    End Sub

    Private Sub SignedFileBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SignedFileBrowse.Click

        If (SignedFileEdit.Text.Length > 0) Then
            SaveFileDialog1.FileName = SignedFileEdit.Text
        End If

        If (SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
            SignedFileEdit.Text = SaveFileDialog1.FileName
        End If

    End Sub

    Private Sub OriginalFileEdit_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OriginalFileEdit.TextChanged
        SignedFileEdit.Text = OriginalFileEdit.Text + ".p7s"
    End Sub

    Private Sub ButtonSign_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSign.Click
        sign(OriginalFileEdit.Text, SignedFileEdit.Text)
    End Sub


    Private Sub sign(ByVal SrcFile As String, ByVal DestFile As String)

        '   
        Dim inputData As Byte() = My.Computer.FileSystem.ReadAllBytes(SrcFile)

        '     -  -   .
        '    
        If ((inputData.Length Mod 2) = 1) Then
            System.Array.Resize(inputData, inputData.Length + 1)
            inputData(inputData.Length - 1) = 32 ' Space character
        End If

        '    ,        
        Dim Store As CAPICOM.Store = New CAPICOM.Store
        Store.Open(CAPICOM.CAPICOM_STORE_LOCATION.CAPICOM_CURRENT_USER_STORE, "My", CAPICOM.CAPICOM_STORE_OPEN_MODE.CAPICOM_STORE_OPEN_READ_ONLY)

        Dim Certificates As CAPICOM.Certificates = Store.Certificates.Find(CAPICOM.CAPICOM_CERTIFICATE_FIND_TYPE.CAPICOM_CERTIFICATE_FIND_KEY_USAGE, CAPICOM.CAPICOM_KEY_USAGE.CAPICOM_DIGITAL_SIGNATURE_KEY_USAGE)
        If (Certificates.Count = 0) Then
            MessageBox.Show("   ")
            Return
        End If

        Dim SelectedCerts As CAPICOM.Certificates

        '        
        Try
            SelectedCerts = Certificates.Select(" ", "    ")
        Catch
            MessageBox.Show("   ")
            Return
        End Try

        ' ,      
        Dim Signer As CAPICOM.Signer = New CAPICOM.Signer
        Signer.Certificate = SelectedCerts.Item(1)

        '  
        Dim SignedData As CAPICOM.SignedData = New CAPICOM.SignedData

        '  
        Dim utils As CAPICOM.Utilities = New CAPICOM.Utilities
        Dim inputString As String = utils.ByteArrayToBinaryString(inputData)
        SignedData.Content = inputString

        '  .        - 
        '        Base64 
        Dim outputData = SignedData.Sign(Signer, False, CAPICOM.CAPICOM_ENCODING_TYPE.CAPICOM_ENCODE_BASE64)

        '  Base64 ,    .
        Dim result() As Byte
        result = System.Convert.FromBase64String(outputData)

        '    
        My.Computer.FileSystem.WriteAllBytes(DestFile, result, False)

        MessageBox.Show("Message Signed")

    End Sub

End Class
